%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Corner_Nodes = Shell_Corners_From_Node(Element_ID, Node_ID)

% Существование элемента Element_ID должно проверяться вне данной функции до ее вызова
% Принадлежность элемента Element_ID к типу Quad или Tria должна проверяться вне данной функции до ее вызова
% Принадлежность узла Node_ID к элементу Element_ID должна проверяться вне данной функции до ее вызова

global DB_ELEMENTS;
global AT_ELEMENTS;

Corner_Nodes = [];

if (~(strcmp(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type, 'Quad') || strcmp(DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.type, 'Tria')))
    return;
end

switch DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.N_nodes
    
    case {3, 4}
        
        Corner_Nodes = Node_ID;
        
    case 6
        
        [member_flag, location] = ismember(Node_ID, DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4:6));
        
        if (member_flag)
            
            Corner_Nodes = zeros(2,1);
            
            switch (location + 3)
                case 4
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
                case 5
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
                case 6
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
            end
            
        else
            
            Corner_Nodes = Node_ID;
            
        end
        
    case 8
        
        [member_flag, location] = ismember(Node_ID, DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(5:8));
        
        if (member_flag)
            
            Corner_Nodes = zeros(2,1);
            
            switch (location + 4)
                case 5
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
                case 6
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(2);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
                case 7
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(3);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4);
                case 8
                    Corner_Nodes(1) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(4);
                    Corner_Nodes(2) = DB_ELEMENTS{AT_ELEMENTS(Element_ID)}.Nodes(1);
            end
            
        else
            
            Corner_Nodes = Node_ID;
            
        end
    
end
